// ============================================================================
// Module Name: IPat_Bin2Gray
// Revision: 20170923a
// Author: Altmo toolbox
// Description:
//  + Gray code converter from binary
// ============================================================================

`timescale 1ps/100fs

module IPat_Bin2Gray (
    i_bin,
    o_gray
);

// parameter ==================================================================
parameter P_IPAT_BIN2GRAY_DWIDTH = 4;

// local parameter ============================================================
localparam LP_DWIDTH = P_IPAT_BIN2GRAY_DWIDTH;

localparam LP_UD = 1;	// unit delay to avoid racing

// port definition ============================================================
input	[LP_DWIDTH-1:0]	i_bin;		// binary input
output	[LP_DWIDTH-1:0]	o_gray;	// gray code output


// register and wire definition ===============================================

// logic ======================================================================

genvar i;
generate
    for (i=0; i<LP_DWIDTH; i=i+1) begin: bin2gray
        if (i==LP_DWIDTH-1) begin
            assign o_gray[i] = i_bin[i];
        end
        else begin
            assign o_gray[i] = i_bin[i+1]^i_bin[i];
        end
    end
endgenerate

endmodule
