// ============================================================================
// Module Name: IPat_Gray2Bin
// Revision: 20170923a
// Author: Altmo toolbox
// Description:
//  + Binay converter from binary from gray code
// ============================================================================

`timescale 1ps/100fs

module IPat_Gray2Bin (
    i_gray,
    o_bin
);

// parameter ==================================================================
parameter P_IPAT_GRAY2BIN_DWIDTH = 4;

// local parameter ============================================================
localparam LP_DWIDTH = P_IPAT_GRAY2BIN_DWIDTH;

localparam LP_UD = 1;	// unit delay to avoid racing

// port definition ============================================================
input	[LP_DWIDTH-1:0]	i_gray;		// gray code input
output	[LP_DWIDTH-1:0]	o_bin;	// binary code output


// register and wire definition ===============================================

// logic ======================================================================

genvar i;
generate
    for(i=0; i<LP_DWIDTH; i=i+1) begin: gray2bin
        if (i==LP_DWIDTH-1) begin
            assign o_bin[i] = i_gray[i];
        end
        else begin
            assign o_bin[i] = o_bin[i+1]^i_gray[i];
        end
    end
endgenerate

endmodule
